import { ElementRef, Renderer2, ChangeDetectorRef, AfterViewInit, OnDestroy, OnInit, EventEmitter, OnChanges, SimpleChanges, QueryList, AfterContentInit } from '@angular/core';
import { CarouselSlideDirective } from "./carousel-slide.directive";
import * as i0 from "@angular/core";
export declare class CarouselComponent implements OnInit, AfterViewInit, AfterContentInit, OnChanges, OnDestroy {
    private _renderer;
    private _cdRef;
    showPageIndicator: boolean;
    showPagination: boolean;
    showMask: boolean;
    maskColor: string;
    containerClass: string;
    currPage: number;
    noResultsText: string;
    currPageChange: EventEmitter<number>;
    carousel: ElementRef;
    slides: QueryList<CarouselSlideDirective>;
    pages: number[];
    private _windowResizeSub;
    private _slidesSub;
    constructor(_renderer: Renderer2, _cdRef: ChangeDetectorRef);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterViewInit(): void;
    ngAfterContentInit(): void;
    next(): void;
    prev(): void;
    goToPage(page: number): void;
    private _setScrollPosition;
    getPages(): number[];
    updatePages(): void;
    get carouselNativeElement(): HTMLDivElement;
    get isFirstPage(): boolean;
    get isLastPage(): boolean;
    get maskStyles(): {
        '-webkit-mask-image': string;
        'background-color': string;
    };
    get maskGradient(): string;
    subscribeToWindowResize(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<CarouselComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CarouselComponent, "nw-carousel", ["nw-carousel"], { "showPageIndicator": { "alias": "showPageIndicator"; "required": false; }; "showPagination": { "alias": "showPagination"; "required": false; }; "showMask": { "alias": "showMask"; "required": false; }; "maskColor": { "alias": "maskColor"; "required": false; }; "containerClass": { "alias": "containerClass"; "required": false; }; "currPage": { "alias": "currPage"; "required": false; }; "noResultsText": { "alias": "noResultsText"; "required": false; }; }, { "currPageChange": "currPageChange"; }, ["slides"], [".pagination-left", "*", ".pagination-right", ".pagination-indicators"], false, never>;
}
