import { Component, ChangeDetectionStrategy, Input, ViewChild, Output, EventEmitter, ContentChildren } from '@angular/core';
import { trigger, transition, style, animate, AUTO_STYLE } from '@angular/animations';
import { debounceTime } from "rxjs/operators";
import { CarouselSlideDirective } from "./carousel-slide.directive";
import { fromEvent } from 'rxjs';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
const _c0 = ["carousel"];
const _c1 = [[["", 8, "pagination-left"]], "*", [["", 8, "pagination-right"]], [["", 8, "pagination-indicators"]]];
const _c2 = [".pagination-left", "*", ".pagination-right", ".pagination-indicators"];
function CarouselComponent_div_1_Template(rf, ctx) { if (rf & 1) {
    const _r1 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "div", 8)(1, "button", 9);
    i0.ɵɵlistener("click", function CarouselComponent_div_1_Template_button_click_1_listener() { i0.ɵɵrestoreView(_r1); const ctx_r1 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r1.prev()); });
    i0.ɵɵelementEnd()();
} }
function CarouselComponent_div_4_div_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "div", 13);
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵproperty("@collapse", undefined)("ngStyle", ctx_r1.maskStyles);
} }
function CarouselComponent_div_4_div_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "div", 14);
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵproperty("@collapse", undefined)("ngStyle", ctx_r1.maskStyles);
} }
function CarouselComponent_div_4_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div", 10);
    i0.ɵɵtemplate(1, CarouselComponent_div_4_div_1_Template, 1, 2, "div", 11)(2, CarouselComponent_div_4_div_2_Template, 1, 2, "div", 12);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngIf", !ctx_r1.isFirstPage);
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngIf", !ctx_r1.isLastPage);
} }
function CarouselComponent_p_8_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "p", 15);
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵadvance();
    i0.ɵɵtextInterpolate(ctx_r1.noResultsText);
} }
function CarouselComponent_div_9_Template(rf, ctx) { if (rf & 1) {
    const _r3 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "div", 8)(1, "button", 16);
    i0.ɵɵlistener("click", function CarouselComponent_div_9_Template_button_click_1_listener() { i0.ɵɵrestoreView(_r3); const ctx_r1 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r1.next()); });
    i0.ɵɵelementEnd()();
} }
function CarouselComponent_div_11_a_1_Template(rf, ctx) { if (rf & 1) {
    const _r4 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "a", 19);
    i0.ɵɵlistener("click", function CarouselComponent_div_11_a_1_Template_a_click_0_listener() { const page_r5 = i0.ɵɵrestoreView(_r4).$implicit; const ctx_r1 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r1.goToPage(page_r5)); });
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const page_r5 = ctx.$implicit;
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵclassProp("active", page_r5 === ctx_r1.currPage);
} }
function CarouselComponent_div_11_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div", 17);
    i0.ɵɵtemplate(1, CarouselComponent_div_11_a_1_Template, 1, 2, "a", 18);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngForOf", ctx_r1.pages);
} }
export class CarouselComponent {
    constructor(_renderer, _cdRef) {
        this._renderer = _renderer;
        this._cdRef = _cdRef;
        this.showPageIndicator = true;
        this.showPagination = true;
        this.showMask = true;
        this.maskColor = '#ffffff';
        this.currPage = 0;
        this.noResultsText = "No results";
        this.currPageChange = new EventEmitter();
        this.pages = [];
    }
    ngOnInit() {
        this.subscribeToWindowResize();
    }
    ngOnChanges(changes) {
        if (changes.currPage && changes.currPage.previousValue !== changes.currPage.currentValue) {
            this._setScrollPosition(this.currPage);
        }
    }
    ngAfterViewInit() {
        this.updatePages();
        if (this.currPage !== 0) {
            this._setScrollPosition(this.currPage);
        }
    }
    ngAfterContentInit() {
        this._slidesSub = this.slides.changes.subscribe(res => {
            this.updatePages();
        });
    }
    next() {
        this.goToPage(Math.min(this.pages.length - 1, this.currPage + 1));
    }
    prev() {
        this.goToPage(Math.max(0, this.currPage - 1));
    }
    goToPage(page) {
        this.currPage = page;
        this.currPageChange.emit(this.currPage);
        this._setScrollPosition(page);
    }
    _setScrollPosition(page) {
        const carouselWidth = this.carouselNativeElement.clientWidth;
        const newScrollPosition = page * carouselWidth;
        this._renderer.setProperty(this.carouselNativeElement, 'scrollLeft', newScrollPosition);
    }
    getPages() {
        const estimatedPages = +(this.carouselNativeElement.scrollWidth / this.carouselNativeElement.clientWidth).toFixed(1);
        const numOfPages = Math.ceil(estimatedPages);
        return [...Array(numOfPages).fill(1)].map((_, i) => i);
    }
    updatePages() {
        this.pages = this.getPages();
        this._cdRef.detectChanges();
    }
    get carouselNativeElement() {
        return this.carousel.nativeElement;
    }
    get isFirstPage() {
        return this.currPage === 0;
    }
    get isLastPage() {
        return this.currPage === this.pages[this.pages.length - 1];
    }
    get maskStyles() {
        return {
            '-webkit-mask-image': `linear-gradient(to left, rgba(0,0,0,0), ${this.maskColor})`,
            'background-color': `${this.maskColor}`
        };
    }
    get maskGradient() {
        return `linear-gradient(to left, rgba(0,0,0,0), ${this.maskColor})`;
    }
    subscribeToWindowResize() {
        this._windowResizeSub = fromEvent(window, 'resize')
            .pipe(debounceTime(100))
            .subscribe(_ => {
            this.goToPage(0);
            this.updatePages();
        });
    }
    ngOnDestroy() {
        this._windowResizeSub.unsubscribe();
        this._slidesSub.unsubscribe();
    }
}
CarouselComponent.ɵfac = function CarouselComponent_Factory(t) { return new (t || CarouselComponent)(i0.ɵɵdirectiveInject(i0.Renderer2), i0.ɵɵdirectiveInject(i0.ChangeDetectorRef)); };
CarouselComponent.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: CarouselComponent, selectors: [["nw-carousel"]], contentQueries: function CarouselComponent_ContentQueries(rf, ctx, dirIndex) { if (rf & 1) {
        i0.ɵɵcontentQuery(dirIndex, CarouselSlideDirective, 4);
    } if (rf & 2) {
        let _t;
        i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.slides = _t);
    } }, viewQuery: function CarouselComponent_Query(rf, ctx) { if (rf & 1) {
        i0.ɵɵviewQuery(_c0, 7);
    } if (rf & 2) {
        let _t;
        i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.carousel = _t.first);
    } }, inputs: { showPageIndicator: "showPageIndicator", showPagination: "showPagination", showMask: "showMask", maskColor: "maskColor", containerClass: "containerClass", currPage: "currPage", noResultsText: "noResultsText" }, outputs: { currPageChange: "currPageChange" }, exportAs: ["nw-carousel"], features: [i0.ɵɵNgOnChangesFeature], ngContentSelectors: _c2, decls: 13, vars: 6, consts: [["carousel", ""], [1, "carousel-container"], ["class", "pagination-container", 4, "ngIf"], [1, "carousel-content"], ["class", "pagination-masks", 4, "ngIf"], [1, "carousel", 3, "ngClass"], ["class", "nw-text text-center", 4, "ngIf"], ["class", "page-indicators", 4, "ngIf"], [1, "pagination-container"], [1, "btn", "btn-carousel", "btn-carousel-prev", 3, "click"], [1, "pagination-masks"], ["class", "pagination-mask pagination-mask-start", 3, "ngStyle", 4, "ngIf"], ["class", "pagination-mask pagination-mask-end", 3, "ngStyle", 4, "ngIf"], [1, "pagination-mask", "pagination-mask-start", 3, "ngStyle"], [1, "pagination-mask", "pagination-mask-end", 3, "ngStyle"], [1, "nw-text", "text-center"], [1, "btn", "btn-carousel", "btn-carousel-next", 3, "click"], [1, "page-indicators"], ["href", "javascript:;", "class", "page-indicator", 3, "active", "click", 4, "ngFor", "ngForOf"], ["href", "javascript:;", 1, "page-indicator", 3, "click"]], template: function CarouselComponent_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵprojectionDef(_c1);
        i0.ɵɵelementStart(0, "div", 1);
        i0.ɵɵtemplate(1, CarouselComponent_div_1_Template, 2, 0, "div", 2);
        i0.ɵɵprojection(2);
        i0.ɵɵelementStart(3, "div", 3);
        i0.ɵɵtemplate(4, CarouselComponent_div_4_Template, 3, 2, "div", 4);
        i0.ɵɵelementStart(5, "div", 5, 0);
        i0.ɵɵprojection(7, 1);
        i0.ɵɵtemplate(8, CarouselComponent_p_8_Template, 2, 1, "p", 6);
        i0.ɵɵelementEnd()();
        i0.ɵɵtemplate(9, CarouselComponent_div_9_Template, 2, 0, "div", 2);
        i0.ɵɵprojection(10, 2);
        i0.ɵɵelementEnd();
        i0.ɵɵtemplate(11, CarouselComponent_div_11_Template, 2, 1, "div", 7);
        i0.ɵɵprojection(12, 3);
    } if (rf & 2) {
        i0.ɵɵadvance();
        i0.ɵɵproperty("ngIf", ctx.showPagination && !ctx.isFirstPage);
        i0.ɵɵadvance(3);
        i0.ɵɵproperty("ngIf", ctx.showMask && ctx.pages.length > 1);
        i0.ɵɵadvance();
        i0.ɵɵproperty("ngClass", ctx.containerClass);
        i0.ɵɵadvance(3);
        i0.ɵɵproperty("ngIf", ctx.slides.length === 0);
        i0.ɵɵadvance();
        i0.ɵɵproperty("ngIf", ctx.showPagination && !ctx.isLastPage);
        i0.ɵɵadvance(2);
        i0.ɵɵproperty("ngIf", ctx.showPageIndicator && ctx.pages.length > 1);
    } }, dependencies: [i1.NgClass, i1.NgForOf, i1.NgIf, i1.NgStyle], encapsulation: 2, data: { animation: [
            trigger('collapse', [
                transition(':leave', [
                    style({ width: AUTO_STYLE }),
                    animate(`300ms linear`, style({ width: 0 }))
                ])
            ])
        ] }, changeDetection: 0 });
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(CarouselComponent, [{
        type: Component,
        args: [{
                selector: 'nw-carousel',
                template: `
        <div class="carousel-container">
            <div class="pagination-container" *ngIf="showPagination && !isFirstPage">
                <button class="btn btn-carousel btn-carousel-prev" (click)="prev()"></button>
            </div>

            <ng-content select=".pagination-left"></ng-content>

            <div class="carousel-content">
                <div class="pagination-masks" *ngIf="showMask && pages.length > 1">
                    <div class="pagination-mask pagination-mask-start" *ngIf="!isFirstPage" @collapse
                        [ngStyle]="maskStyles"></div>

                    <div class="pagination-mask pagination-mask-end" *ngIf="!isLastPage" @collapse
                        [ngStyle]="maskStyles"></div>
                </div>

                <div class="carousel" #carousel [ngClass]="containerClass">
                    <ng-content></ng-content>

                    <p *ngIf="slides.length === 0" class="nw-text text-center">{{noResultsText}}</p>
                </div>
            </div>

            <div class="pagination-container" *ngIf="showPagination && !isLastPage">
                <button class="btn btn-carousel btn-carousel-next" (click)="next()"></button>
            </div>

            <ng-content select=".pagination-right"></ng-content>
        </div>

        <div class="page-indicators" *ngIf="showPageIndicator && pages.length > 1">
            <a href="javascript:;" class="page-indicator" *ngFor="let page of pages"
                [class.active]="page === currPage"
                (click)="goToPage(page)"></a>
        </div>

        <ng-content select=".pagination-indicators"></ng-content>
    `,
                changeDetection: ChangeDetectionStrategy.OnPush,
                exportAs: 'nw-carousel',
                animations: [
                    trigger('collapse', [
                        transition(':leave', [
                            style({ width: AUTO_STYLE }),
                            animate(`300ms linear`, style({ width: 0 }))
                        ])
                    ])
                ]
            }]
    }], () => [{ type: i0.Renderer2 }, { type: i0.ChangeDetectorRef }], { showPageIndicator: [{
            type: Input
        }], showPagination: [{
            type: Input
        }], showMask: [{
            type: Input
        }], maskColor: [{
            type: Input
        }], containerClass: [{
            type: Input
        }], currPage: [{
            type: Input
        }], noResultsText: [{
            type: Input
        }], currPageChange: [{
            type: Output
        }], carousel: [{
            type: ViewChild,
            args: ['carousel', { static: true }]
        }], slides: [{
            type: ContentChildren,
            args: [CarouselSlideDirective]
        }] }); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(CarouselComponent, { className: "CarouselComponent" }); })();
