import { ElementRef, OnInit, OnChanges, SimpleChanges, OnDestroy } from '@angular/core';
import { Area, CurveFactory } from 'd3-shape';
import { ChartComponent } from '../chart.component';
import { ScaleLinear } from 'd3-scale';
import { Selection } from 'd3-selection';
import { ChartUtils } from '../chart.utils';
import { NwXAxisScale } from '../axis/models/XAxisScale';
import * as i0 from "@angular/core";
type AreaDatum = [number, number] | [number, number, number];
export declare class AreaDirective implements OnInit, OnChanges, OnDestroy {
    private _elRef;
    private _chart;
    private _chartUtils;
    /**
     * Each data entry may have 2 or 3 values. If there are 3 the area is drawn within the bounds.
     *
     * If there are 2 the area is drawn to the chart height
     */
    data: Array<AreaDatum>;
    xDomain: [number, number];
    yDomain: [number, number];
    animDuration: number;
    curve: CurveFactory;
    easing: (normalizedTime: number) => number;
    xScale: NwXAxisScale;
    areaSelection: Selection<SVGPathElement, Array<AreaDatum>, SVGElement, any>;
    area: Area<AreaDatum>;
    yScale: ScaleLinear<number, number>;
    private _chartResizeSub;
    constructor(_elRef: ElementRef, _chart: ChartComponent, _chartUtils: ChartUtils);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    setDomains(): void;
    setArea(): void;
    drawArea(): void;
    updateArea(): void;
    private _subscribeToChartResize;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AreaDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<AreaDirective, "path[nw-area]", ["nw-area"], { "data": { "alias": "nw-area"; "required": false; }; "xDomain": { "alias": "xDomain"; "required": false; }; "yDomain": { "alias": "yDomain"; "required": false; }; "animDuration": { "alias": "animDuration"; "required": false; }; "curve": { "alias": "curve"; "required": false; }; "easing": { "alias": "easing"; "required": false; }; "xScale": { "alias": "xScale"; "required": false; }; }, {}, never, never, false, never>;
}
export {};
