import { OnInit, ElementRef, OnChanges, SimpleChanges, OnDestroy } from "@angular/core";
import { Axis, AxisTimeInterval } from 'd3-axis';
import { ChartUtils } from "../chart.utils";
import { Selection } from "d3-selection";
import { ChartComponent } from "../chart.component";
import * as i0 from "@angular/core";
export declare abstract class AxisBase implements OnInit, OnChanges, OnDestroy {
    private _elRef;
    chart: ChartComponent;
    private _chartUtils;
    tickFormat: (value: number | Date | {
        valueOf(): number;
    }) => string;
    tickCount: number | AxisTimeInterval;
    tickSizeOuter: number;
    tickValues: any[];
    showGuidlines: boolean;
    animDuration: number;
    easing: (normalizedTime: number) => number;
    label: string;
    axis: Axis<number | Date | {
        valueOf(): number;
    }>;
    axisSelection: Selection<SVGGElement, Array<[number, number]>, SVGElement, any>;
    axisLabelSelection: Selection<SVGTextElement, any, HTMLElement, any>;
    private _chartResizeSub;
    constructor(_elRef: ElementRef, chart: ChartComponent, _chartUtils: ChartUtils);
    ngOnInit(): void;
    ngOnChanges(c: SimpleChanges): void;
    createAxis(): any;
    setTicks(): void;
    setDomain(): void;
    createLabel(): void;
    render(): any;
    update(): void;
    get fullWidth(): number;
    get fullHeight(): number;
    private _subscribeToChartResize;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AxisBase, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<AxisBase, never, never, { "tickFormat": { "alias": "tickFormat"; "required": false; }; "tickCount": { "alias": "tickCount"; "required": false; }; "tickSizeOuter": { "alias": "tickSizeOuter"; "required": false; }; "tickValues": { "alias": "tickValues"; "required": false; }; "showGuidlines": { "alias": "showGuidlines"; "required": false; }; "animDuration": { "alias": "animDuration"; "required": false; }; "easing": { "alias": "easing"; "required": false; }; "label": { "alias": "label"; "required": false; }; }, {}, never, never, false, never>;
}
