import { ElementRef, EventEmitter } from '@angular/core';
import { AxisBase } from './axis-base';
import { ChartComponent } from '../chart.component';
import { ChartUtils } from "../chart.utils";
import { NwXAxisScale } from './models/XAxisScale';
import * as i0 from "@angular/core";
export declare class XAxisDirective extends AxisBase {
    align: 'top' | 'bottom' | 'center';
    domain: [number, number];
    scale: NwXAxisScale;
    scaleUpdated: EventEmitter<NwXAxisScale>;
    constructor(elRef: ElementRef, chart: ChartComponent, chartUtils: ChartUtils);
    createAxis(): void;
    setTicks(): void;
    setDomain(): void;
    positionLabel(): void;
    render(): void;
    private _getAxisTranslation;
    static ɵfac: i0.ɵɵFactoryDeclaration<XAxisDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<XAxisDirective, "[nw-x-axis]", ["nw-x-axis"], { "align": { "alias": "align"; "required": false; }; "domain": { "alias": "domain"; "required": false; }; "scale": { "alias": "scale"; "required": false; }; }, { "scaleUpdated": "scaleUpdated"; }, never, never, false, never>;
}
