import { ElementRef, OnInit, OnDestroy, EventEmitter, OnChanges, SimpleChanges } from '@angular/core';
import { Selection } from 'd3-selection';
import { BrushBehavior } from 'd3-brush';
import { ChartComponent } from '../chart.component';
import * as i0 from "@angular/core";
export declare class BrushDirective implements OnInit, OnDestroy, OnChanges {
    private _elRef;
    private _chart;
    extent: [[number, number], [number, number]];
    dimension: 'x' | 'y' | '';
    brushEnd: EventEmitter<[[number, number], [number, number]]>;
    brushSelection: Selection<SVGGElement, any, HTMLElement, any>;
    brush: BrushBehavior<any>;
    constructor(_elRef: ElementRef, _chart: ChartComponent);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    initialize(): void;
    reset(): void;
    private _createBrush;
    getExtent(): [[number, number], [number, number]];
    private _subscribeToBrushEndEvent;
    private _clearBrush;
    private _unbindEvents;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<BrushDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<BrushDirective, "svg:g[nw-brush]", ["nw-brush"], { "extent": { "alias": "extent"; "required": false; }; "dimension": { "alias": "dimension"; "required": false; }; }, { "brushEnd": "brushEnd"; }, never, never, false, never>;
}
