import { ElementRef, OnInit, AfterViewInit, EventEmitter, OnDestroy } from '@angular/core';
import { Selection } from 'd3-selection';
import { ChartUtils } from './chart.utils';
import * as i0 from "@angular/core";
export declare class ChartComponent implements OnInit, AfterViewInit, OnDestroy {
    private _elRef;
    chartUtils: ChartUtils;
    w: number;
    h: number;
    margins: {
        top?: number;
        bottom?: number;
        left?: number;
        right?: number;
    };
    chartContainer: ElementRef<SVGGElement>;
    mouseEventCaptureContainer: ElementRef<SVGGElement>;
    hoverOverlay: ElementRef<SVGRectElement>;
    nwMousemove: EventEmitter<[number, number]>;
    nwMouseleave: EventEmitter<null>;
    bgClick: EventEmitter<null>;
    svg: Selection<SVGSVGElement, any, HTMLElement, any>;
    parentElement: HTMLElement;
    private _destroyed$;
    private _chartDimensionsChange$;
    constructor(_elRef: ElementRef<SVGSVGElement>, chartUtils: ChartUtils);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    get width(): number;
    get height(): number;
    setSvg(): void;
    appendContainer(): void;
    setHoverOverlay(): void;
    onBackgroundClick(): void;
    /**
     * As well charts being resized due to the window being resized, another scenario is that
     * the parent element is squeezed or stretched in a reponsive design due to the appearance
     * or disappearance of other elements. For this we use our nwResizeObserver which utilizes
     * ResizeObserver under the hood.
     */
    subscribeToChartResize(): void;
    onChartDimensionsChange(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ChartComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ChartComponent, "svg[nw-chart]", ["nw-chart"], { "w": { "alias": "width"; "required": false; }; "h": { "alias": "height"; "required": false; }; "margins": { "alias": "margins"; "required": false; }; }, { "nwMousemove": "nwMousemove"; "nwMouseleave": "nwMouseleave"; "bgClick": "bgClick"; }, never, ["[nw-x-axis],[nw-y-axis]", ".nw-slot-1", ".nw-slot-2", "*"], false, never>;
}
