import { Injectable } from "@angular/core";
import { easeCubicInOut } from "d3-ease";
import { Subject } from "rxjs";
import * as i0 from "@angular/core";
export class ChartUtils {
    constructor() {
        this._chartResize$ = new Subject();
        this.chartResize$ = this._chartResize$.asObservable();
    }
    static areDatasetsEqual(a, b) {
        return a.length === b.length &&
            a.every((value, index) => {
                return value[0] === b[index][0] && value[1] === b[index][1];
            });
    }
    static haveDomainsChanged(xDomain, yDomain) {
        return this.hasInputChanged(xDomain) || this.hasInputChanged(yDomain);
    }
    static hasInputChanged(input) {
        return input &&
            !input.firstChange &&
            input.previousValue !== input.currentValue;
    }
    notifyChartResize() {
        this._chartResize$.next();
    }
}
ChartUtils.ANIMATION_DURATION = 1000;
ChartUtils.ANIMATION_EASING = easeCubicInOut;
ChartUtils.ɵfac = function ChartUtils_Factory(t) { return new (t || ChartUtils)(); };
ChartUtils.ɵprov = /*@__PURE__*/ i0.ɵɵdefineInjectable({ token: ChartUtils, factory: ChartUtils.ɵfac });
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(ChartUtils, [{
        type: Injectable
    }], () => [], null); })();
