import { OnInit, ElementRef, OnChanges, SimpleChanges, OnDestroy } from '@angular/core';
import { ChartUtils } from '../chart.utils';
import { Selection } from 'd3-selection';
import { ScaleLinear } from 'd3-scale';
import { ChartComponent } from '../chart.component';
import { NwXAxisScale } from '../axis/models/XAxisScale';
import * as i0 from "@angular/core";
export declare class CircleDirective implements OnInit, OnChanges, OnDestroy {
    private _elRef;
    private _chart;
    private _chartUtils;
    point: [number, number];
    xDomain: [number, number];
    yDomain: [number, number];
    animDuration: number;
    easing: (normalizedTime: number) => number;
    xScale: NwXAxisScale;
    circle: Selection<SVGCircleElement, [number, number], SVGElement, any>;
    yScale: ScaleLinear<number, number>;
    private _chartResizeSub;
    constructor(_elRef: ElementRef, _chart: ChartComponent, _chartUtils: ChartUtils);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    setDomains(): void;
    draw(): void;
    update(): void;
    get transform(): string;
    get x(): number;
    get y(): number;
    private _subscribeToChartResize;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<CircleDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<CircleDirective, "circle[nw-circle]", ["nw-circle"], { "point": { "alias": "nw-circle"; "required": false; }; "xDomain": { "alias": "xDomain"; "required": false; }; "yDomain": { "alias": "yDomain"; "required": false; }; "animDuration": { "alias": "animDuration"; "required": false; }; "easing": { "alias": "easing"; "required": false; }; "xScale": { "alias": "xScale"; "required": false; }; }, {}, never, never, false, never>;
}
