import { ElementRef, OnChanges, OnDestroy, OnInit, SimpleChanges } from "@angular/core";
import { ScaleLinear } from "d3-scale";
import { Selection } from 'd3-selection';
import { NwXAxisScale } from "../axis/models/XAxisScale";
import { ChartComponent } from "../chart.component";
import { ChartUtils } from "../chart.utils";
import * as i0 from "@angular/core";
export declare class ForeignObjectDirective implements OnInit, OnChanges, OnDestroy {
    private _elRef;
    private _chart;
    private _chartUtils;
    point: [number, number];
    xDomain: [number, number];
    yDomain: [number, number];
    animDuration: number;
    easing: (normalizedTime: number) => number;
    xScale: NwXAxisScale;
    foreignObject: Selection<SVGForeignObjectElement, [number, number], SVGElement, any>;
    yScale: ScaleLinear<number, number>;
    private _chartResizeSub;
    constructor(_elRef: ElementRef, _chart: ChartComponent, _chartUtils: ChartUtils);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    setDomains(): void;
    draw(): void;
    update(): void;
    get transform(): string;
    get x(): number;
    get y(): number;
    private _subscribeToChartResize;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ForeignObjectDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<ForeignObjectDirective, "[nw-foreign-object]", ["nw-foreign-object"], { "point": { "alias": "point"; "required": false; }; "xDomain": { "alias": "xDomain"; "required": false; }; "yDomain": { "alias": "yDomain"; "required": false; }; "animDuration": { "alias": "animDuration"; "required": false; }; "easing": { "alias": "easing"; "required": false; }; "xScale": { "alias": "xScale"; "required": false; }; }, {}, never, never, false, never>;
}
