import { OnDestroy, OnInit, OnChanges, SimpleChanges, ElementRef, EventEmitter, NgZone, Renderer2, ChangeDetectorRef } from '@angular/core';
import { DropdownService } from "./dropdown.service";
import * as i0 from "@angular/core";
export declare class DropdownDirective implements OnInit, OnChanges, OnDestroy {
    private _service;
    private _elRef;
    private _zone;
    private _renderer;
    private _cdRef;
    autoClose: boolean | "inside" | "outside";
    elementsToIgnore: HTMLElement[];
    selectorsToIgnore: string[];
    disabled: boolean;
    opened: EventEmitter<null>;
    closed: EventEmitter<null>;
    isOpen: boolean;
    private _toggleSubscription;
    private _documentUnlistener;
    private _escapeUnlistener;
    constructor(_service: DropdownService, _elRef: ElementRef, _zone: NgZone, _renderer: Renderer2, _cdRef: ChangeDetectorRef);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    open(): void;
    close(): void;
    private _subscribeToToggle;
    onDocumentClick(event: MouseEvent): void;
    onEscape(event: KeyboardEvent): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DropdownDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<DropdownDirective, "[nwDropdown]", ["nw-dropdown"], { "autoClose": { "alias": "autoClose"; "required": false; }; "elementsToIgnore": { "alias": "elementsToIgnore"; "required": false; }; "selectorsToIgnore": { "alias": "selectorsToIgnore"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; }, { "opened": "opened"; "closed": "closed"; }, never, never, false, never>;
}
