import { Injectable } from "@angular/core";
import { BehaviorSubject } from "rxjs";
import * as i0 from "@angular/core";
export class DropdownService {
    constructor() {
        this._toggle$ = new BehaviorSubject(false);
        this.toggle$ = this._toggle$.asObservable();
    }
    toggle() {
        this._toggle$.next(!this._toggle$.value);
    }
    open() {
        this._toggle$.next(true);
    }
    close() {
        this._toggle$.next(false);
    }
    isHTMLElementContainedIn(element, containers) {
        return containers
            // Filter out falsey elements
            .filter(el => el)
            .some(item => item.contains(element));
    }
    isHTMLElementInPath(event, selectors) {
        // Obtain the path from the event source to the document root
        const path = (event.path || (event.composedPath && event.composedPath()));
        return path
            // Map to parentNode so we can use querySelector
            .map(el => el.parentNode)
            // Filter out undefined parent nodes
            .filter(p => p)
            // Check if any of the parentNodes match any of the selectors
            .some(p => selectors.some(s => Boolean(p.querySelector(s))));
    }
}
DropdownService.ɵfac = function DropdownService_Factory(t) { return new (t || DropdownService)(); };
DropdownService.ɵprov = /*@__PURE__*/ i0.ɵɵdefineInjectable({ token: DropdownService, factory: DropdownService.ɵfac });
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(DropdownService, [{
        type: Injectable
    }], null, null); })();
