import { OnInit, ElementRef, ChangeDetectorRef, OnDestroy, EventEmitter } from '@angular/core';
import { FormControl } from "@angular/forms";
import { IValidationChange } from "./models/IValidationChange";
import * as i0 from "@angular/core";
export declare class EmailInputComponent implements OnInit, OnDestroy {
    private _cdRef;
    emails: string[];
    /**
     * Applied to the HTMLInputElement. Mostly useful for label using the "for" attribute
     */
    inputId: string;
    placeholder: string;
    persistentPlaceholder: string;
    /**
     * A list of strings or RegExp to be matched against the inputted list of emails. Any emails that
     * match entries in the blacklist will be marked as invalid
     */
    blacklist: (string | RegExp)[];
    updated: EventEmitter<IValidationChange>;
    inputEl: ElementRef;
    container: ElementRef;
    emailInputControl: FormControl<string>;
    isPillSelected: boolean;
    private _validationFormControl;
    private _submitKeys;
    private _valueChangesSub;
    constructor(_cdRef: ChangeDetectorRef);
    ngOnInit(): void;
    private _subscribeToValueChanges;
    removeEmail(email: string): void;
    onBlur(): void;
    onKeydown(event: KeyboardEvent): void;
    onTab(event: KeyboardEvent): void;
    isValid(email: string): boolean;
    onContainerClick(event: MouseEvent): void;
    onPaste(event: ClipboardEvent): void;
    private _addEmail;
    focus(): void;
    onBackspace(): void;
    private _emitValidationChange;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<EmailInputComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EmailInputComponent, "nw-email-input", ["nw-email-input"], { "emails": { "alias": "emails"; "required": false; }; "inputId": { "alias": "inputId"; "required": false; }; "placeholder": { "alias": "placeholder"; "required": false; }; "persistentPlaceholder": { "alias": "persistentPlaceholder"; "required": false; }; "blacklist": { "alias": "blacklist"; "required": false; }; }, { "updated": "updated"; }, never, never, false, never>;
}
