import { Component, ViewChild, ChangeDetectionStrategy, Input, Output, EventEmitter } from '@angular/core';
import { FormControl, Validators } from "@angular/forms";
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
import * as i2 from "@angular/forms";
const _c0 = ["inputEl"];
const _c1 = ["container"];
function EmailInputComponent_div_2_Template(rf, ctx) { if (rf & 1) {
    const _r2 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "div", 7)(1, "span", 8);
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementStart(3, "button", 9);
    i0.ɵɵlistener("click", function EmailInputComponent_div_2_Template_button_click_3_listener() { const email_r3 = i0.ɵɵrestoreView(_r2).$implicit; const ctx_r3 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r3.removeEmail(email_r3)); });
    i0.ɵɵtext(4, "\u00D7");
    i0.ɵɵelementEnd()();
} if (rf & 2) {
    const email_r3 = ctx.$implicit;
    const last_r5 = ctx.last;
    const ctx_r3 = i0.ɵɵnextContext();
    i0.ɵɵclassProp("invalid", !ctx_r3.isValid(email_r3))("selected", last_r5 && ctx_r3.isPillSelected);
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate(email_r3);
} }
export class EmailInputComponent {
    constructor(_cdRef) {
        this._cdRef = _cdRef;
        this.emails = [];
        /**
         * Applied to the HTMLInputElement. Mostly useful for label using the "for" attribute
         */
        this.inputId = "";
        this.placeholder = '';
        this.persistentPlaceholder = '';
        /**
         * A list of strings or RegExp to be matched against the inputted list of emails. Any emails that
         * match entries in the blacklist will be marked as invalid
         */
        this.blacklist = [];
        this.updated = new EventEmitter();
        this.emailInputControl = new FormControl("", Validators.email);
        this.isPillSelected = false;
        this._validationFormControl = new FormControl();
        this._submitKeys = [",", "Enter", " ", ";"];
    }
    ngOnInit() {
        this._subscribeToValueChanges();
        this._emitValidationChange();
    }
    _subscribeToValueChanges() {
        this._valueChangesSub = this.emailInputControl.valueChanges.subscribe(value => {
            if (value.length > 0) {
                this.isPillSelected = false;
                this._cdRef.detectChanges();
            }
        });
    }
    removeEmail(email) {
        const index = this.emails.indexOf(email, 0);
        if (index > -1) {
            this.emails.splice(index, 1);
            this._emitValidationChange();
        }
    }
    onBlur() {
        this.isPillSelected = false;
        this._addEmail();
    }
    onKeydown(event) {
        const index = this._submitKeys.indexOf(event.key, 0);
        if (index > -1) {
            event.preventDefault();
            this._addEmail();
            this.focus();
        }
        if (event.key === "Escape") {
            event.stopPropagation();
            this.emailInputControl.setValue('');
            this.inputEl.nativeElement.blur();
        }
    }
    onTab(event) {
        /**
         * If the input has a value, add it as an entry.
         *
         * Otherwise, allow the default tab behaviour
         */
        if (this.emailInputControl.value.length > 0) {
            event.preventDefault();
            this._addEmail();
            this.focus();
        }
    }
    isValid(email) {
        this._validationFormControl.setValue(email);
        const isBlacklisted = this.blacklist.some(item => {
            /**
             * If item in blacklist is a string, create a regular expression to match the full
             * case-insenstive string
             */
            if (typeof item === 'string') {
                return email.match(new RegExp(`^${item}$`, 'i'));
            }
            return email.match(item);
        });
        return Validators.email(this._validationFormControl) === null && !isBlacklisted;
    }
    onContainerClick(event) {
        /**
         * We're only interested in this event if it originates from the container element.
         *
         * We don't care about events that bubble up from child elements.
         */
        if (event.target === this.container.nativeElement) {
            this.focus();
        }
    }
    onPaste(event) {
        if (event.clipboardData) {
            event.preventDefault();
            this.emailInputControl.markAsDirty();
            const selectionStart = this.inputEl.nativeElement.selectionStart;
            const selectionEnd = this.inputEl.nativeElement.selectionEnd;
            const controlValue = this.emailInputControl.value;
            let pastedData = event.clipboardData.getData("text");
            /**
             * We need to check if the input already has a value when the user pasted
             */
            if (this.emailInputControl.value.length) {
                /**
                 * The user has selected text in the input
                 */
                if (selectionStart !== selectionEnd) {
                    const newValue = controlValue.slice(0, selectionStart) + controlValue.slice(selectionEnd);
                    pastedData = newValue.slice(0, selectionStart) + pastedData + newValue.slice(selectionStart);
                }
                else {
                    pastedData = controlValue.slice(0, selectionStart) + pastedData + controlValue.slice(selectionStart);
                }
            }
            const items = pastedData
                .split(/\s+/)
                .map(item => item.split(/,|;/g))
                .reduce((acc, curr) => acc.concat(curr), [])
                .filter(item => item);
            const lastEmail = items[items.length - 1];
            if (this.isValid(lastEmail)) {
                // Use Set to remove duplicate emails
                this.emails = Array.from(new Set(this.emails.concat(items)));
                this.emailInputControl.setValue('');
            }
            else {
                items.pop();
                // Use Set to remove duplicate emails
                this.emails = Array.from(new Set(this.emails.concat(items)));
                this.emailInputControl.setValue(lastEmail);
            }
            this._emitValidationChange();
        }
    }
    _addEmail() {
        const email = this.emailInputControl.value.trim();
        // We only want to add the entry if it hasn't already been added
        if (email.length && this.emails.indexOf(email) === -1) {
            this.emails = this.emails.concat(this.emailInputControl.value.trim());
            this._emitValidationChange();
        }
        this.emailInputControl.setValue('');
    }
    focus() {
        this.inputEl.nativeElement.focus();
    }
    onBackspace() {
        if (this.emailInputControl.value.length < 1 && this.emails.length > 0) {
            if (this.isPillSelected) {
                this.removeEmail(this.emails[this.emails.length - 1]);
            }
            else {
                this.isPillSelected = true;
            }
        }
    }
    _emitValidationChange() {
        /**
         * isValid is based on the entered emails and does not include the current value of the form control
         */
        const isValid = this.emails.length > 0 && this.emails.every(email => this.isValid(email));
        this.updated.emit({
            isValid: isValid,
            emails: this.emails,
            control: this.emailInputControl
        });
    }
    ngOnDestroy() {
        this._valueChangesSub.unsubscribe();
    }
}
EmailInputComponent.ɵfac = function EmailInputComponent_Factory(t) { return new (t || EmailInputComponent)(i0.ɵɵdirectiveInject(i0.ChangeDetectorRef)); };
EmailInputComponent.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: EmailInputComponent, selectors: [["nw-email-input"]], viewQuery: function EmailInputComponent_Query(rf, ctx) { if (rf & 1) {
        i0.ɵɵviewQuery(_c0, 7);
        i0.ɵɵviewQuery(_c1, 7);
    } if (rf & 2) {
        let _t;
        i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.inputEl = _t.first);
        i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.container = _t.first);
    } }, inputs: { emails: "emails", inputId: "inputId", placeholder: "placeholder", persistentPlaceholder: "persistentPlaceholder", blacklist: "blacklist" }, outputs: { updated: "updated" }, exportAs: ["nw-email-input"], decls: 8, vars: 10, consts: [["container", ""], ["inputEl", ""], [1, "emails-container", "form-control", "input-lg", 3, "click", "paste"], ["class", "pill pill-sm", 3, "invalid", "selected", 4, "ngFor", "ngForOf"], [1, "input-container"], [1, "pill", "pill-sm", "pill-hidden"], ["type", "text", 3, "keydown", "keydown.tab", "keyup.backspace", "blur", "id", "formControl", "placeholder"], [1, "pill", "pill-sm"], [1, "pill-label"], [1, "close", 3, "click"]], template: function EmailInputComponent_Template(rf, ctx) { if (rf & 1) {
        const _r1 = i0.ɵɵgetCurrentView();
        i0.ɵɵelementStart(0, "div", 2, 0);
        i0.ɵɵlistener("click", function EmailInputComponent_Template_div_click_0_listener($event) { i0.ɵɵrestoreView(_r1); return i0.ɵɵresetView(ctx.onContainerClick($event)); })("paste", function EmailInputComponent_Template_div_paste_0_listener($event) { i0.ɵɵrestoreView(_r1); return i0.ɵɵresetView(ctx.onPaste($event)); });
        i0.ɵɵtemplate(2, EmailInputComponent_div_2_Template, 5, 5, "div", 3);
        i0.ɵɵelementStart(3, "div", 4)(4, "div", 5);
        i0.ɵɵtext(5);
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(6, "input", 6, 1);
        i0.ɵɵlistener("keydown", function EmailInputComponent_Template_input_keydown_6_listener($event) { i0.ɵɵrestoreView(_r1); return i0.ɵɵresetView(ctx.onKeydown($event)); })("keydown.tab", function EmailInputComponent_Template_input_keydown_tab_6_listener($event) { i0.ɵɵrestoreView(_r1); return i0.ɵɵresetView(ctx.onTab($event)); })("keyup.backspace", function EmailInputComponent_Template_input_keyup_backspace_6_listener() { i0.ɵɵrestoreView(_r1); return i0.ɵɵresetView(ctx.onBackspace()); })("blur", function EmailInputComponent_Template_input_blur_6_listener() { i0.ɵɵrestoreView(_r1); return i0.ɵɵresetView(ctx.onBlur()); });
        i0.ɵɵelementEnd()()();
    } if (rf & 2) {
        i0.ɵɵclassProp("show-placeholder", ctx.emails.length < 1 && ctx.emailInputControl.value.length < 1);
        i0.ɵɵattribute("data-placeholder-text", ctx.placeholder);
        i0.ɵɵadvance(2);
        i0.ɵɵproperty("ngForOf", ctx.emails);
        i0.ɵɵadvance();
        i0.ɵɵclassProp("persistent-placeholder", ctx.persistentPlaceholder);
        i0.ɵɵadvance(2);
        i0.ɵɵtextInterpolate(ctx.emailInputControl.value);
        i0.ɵɵadvance();
        i0.ɵɵproperty("id", ctx.inputId)("formControl", ctx.emailInputControl)("placeholder", ctx.persistentPlaceholder);
    } }, dependencies: [i1.NgForOf, i2.DefaultValueAccessor, i2.NgControlStatus, i2.FormControlDirective], encapsulation: 2, changeDetection: 0 });
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(EmailInputComponent, [{
        type: Component,
        args: [{
                selector: 'nw-email-input',
                template: `
        <div class="emails-container form-control input-lg" #container
            [class.show-placeholder]="emails.length < 1 && emailInputControl.value.length < 1"
            (click)="onContainerClick($event)"
            (paste)="onPaste($event)"
            [attr.data-placeholder-text]="placeholder">

            <div class="pill pill-sm" *ngFor="let email of emails; let last = last;"
                [class.invalid]="!isValid(email)"
                [class.selected]="last && isPillSelected">
                <span class="pill-label">{{email}}</span>
                <button class="close" (click)="removeEmail(email)">×</button>
            </div>

            <div class="input-container" [class.persistent-placeholder]="persistentPlaceholder">
                <!-- pill-hidden is an invisble element that controls the width of the input -->
                <div class="pill pill-sm pill-hidden">{{emailInputControl.value}}</div>
                <input type="text" #inputEl [id]="inputId"
                    [formControl]="emailInputControl"
                    (keydown)="onKeydown($event)"
                    (keydown.tab)="onTab($event)"
                    (keyup.backspace)="onBackspace()"
                    [placeholder]="persistentPlaceholder"
                    (blur)="onBlur()">
            </div>
        </div>
    `,
                changeDetection: ChangeDetectionStrategy.OnPush,
                exportAs: 'nw-email-input'
            }]
    }], () => [{ type: i0.ChangeDetectorRef }], { emails: [{
            type: Input
        }], inputId: [{
            type: Input
        }], placeholder: [{
            type: Input
        }], persistentPlaceholder: [{
            type: Input
        }], blacklist: [{
            type: Input
        }], updated: [{
            type: Output
        }], inputEl: [{
            type: ViewChild,
            args: ['inputEl', { static: true }]
        }], container: [{
            type: ViewChild,
            args: ['container', { static: true }]
        }] }); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(EmailInputComponent, { className: "EmailInputComponent" }); })();
