import { OnInit, OnDestroy } from '@angular/core';
import * as i0 from "@angular/core";
export declare class FeatureAlertsDirective implements OnInit, OnDestroy {
    /**
     * This directive shows/hides content depending on whether or not a given feature ID is enabled/disabled in local storage
     * It listens for changes on the FeatureAlertsService _dismissSubject and shows/hides accordingly
     *
     * Implementation :
     *
     * HTML
     * <a (click)=dismiss('feature-id')> New Feature </a>
     * <span *nwFeatureAlert="'feature-id'" class="label label-round label-new ml-4">New</span>
     *
     * Typescript
     * _featureAlertsService = inject(FeatureAlertsService);
     * dismiss(id) {
     *    this._featureAlertsService.dismiss(id);
     * }
     */
    /**
     * ID of the new feature to be stored in local storage
     */
    nwFeatureAlert: string;
    private _isInView;
    private _templateRef;
    private _viewContainer;
    private _featureAlertsService;
    private _destroyed$;
    ngOnInit(): void;
    private _toggleFeatureAlert;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<FeatureAlertsDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<FeatureAlertsDirective, "[nwFeatureAlert]", never, { "nwFeatureAlert": { "alias": "nwFeatureAlert"; "required": false; }; }, {}, never, never, false, never>;
}
