import { Input, Directive, TemplateRef, ViewContainerRef, inject } from '@angular/core';
import { FeatureAlertsService } from './feature-alerts.service';
import { filter, takeUntil } from 'rxjs/operators';
import { Subject } from 'rxjs';
import * as i0 from "@angular/core";
export class FeatureAlertsDirective {
    constructor() {
        this._isInView = false;
        this._templateRef = inject((TemplateRef));
        this._viewContainer = inject(ViewContainerRef);
        this._featureAlertsService = inject(FeatureAlertsService);
        this._destroyed$ = new Subject();
    }
    ngOnInit() {
        this._toggleFeatureAlert(this.nwFeatureAlert);
        this._featureAlertsService.dismiss$.pipe(filter((id) => id === this.nwFeatureAlert), takeUntil(this._destroyed$)).subscribe(id => this._toggleFeatureAlert(id));
    }
    _toggleFeatureAlert(id) {
        const wasAlertDismissed = this._featureAlertsService.wasAlertDismissed(id);
        if (!wasAlertDismissed && !this._isInView) {
            this._viewContainer.createEmbeddedView(this._templateRef);
            this._isInView = true;
        }
        else if (wasAlertDismissed && this._isInView) {
            this._viewContainer.clear();
            this._isInView = false;
        }
    }
    ngOnDestroy() {
        this._destroyed$.next();
        this._destroyed$.complete();
    }
}
FeatureAlertsDirective.ɵfac = function FeatureAlertsDirective_Factory(t) { return new (t || FeatureAlertsDirective)(); };
FeatureAlertsDirective.ɵdir = /*@__PURE__*/ i0.ɵɵdefineDirective({ type: FeatureAlertsDirective, selectors: [["", "nwFeatureAlert", ""]], inputs: { nwFeatureAlert: "nwFeatureAlert" } });
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(FeatureAlertsDirective, [{
        type: Directive,
        args: [{
                selector: '[nwFeatureAlert]'
            }]
    }], null, { nwFeatureAlert: [{
            type: Input
        }] }); })();
