import { Injectable } from '@angular/core';
import { Observable, Subject } from 'rxjs';
import * as i0 from "@angular/core";
import * as i1 from "./windowref";
export class FeatureAlertsService {
    constructor(_w) {
        this._w = _w;
        this.LOCAL_STORAGE_KEY = 'nwAlerts';
        this._dismissSubject = new Subject();
        this.dismiss$ = new Observable();
        this.dismiss$ = this._dismissSubject.asObservable();
    }
    dismiss(id) {
        this._set(Object.assign(Object.assign({}, this._get()), { [id]: { dismissed: true } }));
        this._dismissSubject.next(id);
    }
    enable(id) {
        this._set(Object.assign(Object.assign({}, this._get()), { [id]: { dismissed: false } }));
        this._dismissSubject.next(id);
    }
    wasAlertDismissed(id) {
        const alerts = this._get();
        if (alerts && alerts.hasOwnProperty(id)) {
            return alerts[id].dismissed;
        }
    }
    _get() {
        return JSON.parse(this._w.nativeWindow.localStorage.getItem(this.LOCAL_STORAGE_KEY));
    }
    _set(alerts) {
        this._w.nativeWindow.localStorage.setItem(this.LOCAL_STORAGE_KEY, JSON.stringify(alerts));
    }
}
FeatureAlertsService.ɵfac = function FeatureAlertsService_Factory(t) { return new (t || FeatureAlertsService)(i0.ɵɵinject(i1.WindowRef)); };
FeatureAlertsService.ɵprov = /*@__PURE__*/ i0.ɵɵdefineInjectable({ token: FeatureAlertsService, factory: FeatureAlertsService.ɵfac });
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(FeatureAlertsService, [{
        type: Injectable
    }], () => [{ type: i1.WindowRef }], null); })();
