import { EventEmitter, ElementRef, OnInit, OnDestroy } from "@angular/core";
import * as i0 from "@angular/core";
export declare class ResizeObserverDirective implements OnInit, OnDestroy {
    /**
     * Optional element to listen to the resize event for. If not
     * provided defaults to the element the directive is attached to
     */
    element?: HTMLElement;
    /**
     * A pixel value specifying the minimum change in height or width that triggers the resize event
     */
    tolerance: number;
    nwResize: EventEmitter<null>;
    private _observer;
    private _nwResize;
    private _destroyed$;
    private _currentElementRect;
    constructor(_elRef: ElementRef<HTMLElement>);
    ngOnInit(): void;
    subscribeToResize(): void;
    createObserver(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ResizeObserverDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<ResizeObserverDirective, "[nwResizeObserver]", ["nwResizeObserver"], { "element": { "alias": "element"; "required": false; }; "tolerance": { "alias": "tolerance"; "required": false; }; }, { "nwResize": "nwResize"; }, never, never, false, never>;
}
