import { QueryList, ElementRef, OnInit, ChangeDetectorRef, OnDestroy, AfterContentInit } from '@angular/core';
import { TabDirective } from './tab.directive';
import { TabsService } from './tabs.service';
import * as i0 from "@angular/core";
export declare class TabsComponent implements OnInit, AfterContentInit, OnDestroy {
    private _cdRef;
    private _tabsService;
    size: 'sm' | 'md' | 'lg';
    maskColor: string;
    scrollContainer: ElementRef<HTMLElement>;
    activeBar: ElementRef<HTMLElement>;
    tabs: QueryList<TabDirective>;
    private _scrollAndResizeSub;
    private _activeChangeSub;
    private _transitionEndSub;
    private _tabsChangeSub;
    private _paginationTolerance;
    constructor(_cdRef: ChangeDetectorRef, _tabsService: TabsService);
    ngOnInit(): void;
    ngAfterContentInit(): void;
    subscribeToActiveChange(): void;
    subscribeToTabsChange(): void;
    subscribeToActiveBarTransitionEnd(): void;
    getActiveTab(): TabDirective;
    get tabSizeClass(): string;
    getActiveStyles(): {
        [key: string]: string;
    };
    getScrollEl(): HTMLElement;
    get background(): {
        background: string;
    };
    get clientWidth(): number;
    get shouldShowPagination(): boolean;
    get shouldShowPrev(): boolean;
    get shouldShowNext(): boolean;
    prev(): void;
    next(): void;
    scrollToTabIfRequired(tab: TabDirective): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TabsComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TabsComponent, "nw-tabs", never, { "size": { "alias": "size"; "required": false; }; "maskColor": { "alias": "maskColor"; "required": false; }; }, {}, ["tabs"], ["*"], false, never>;
}
