import { Component, ContentChildren, QueryList, Input, ViewChild, ChangeDetectionStrategy } from '@angular/core';
import { TabDirective } from './tab.directive';
import { fromEvent, merge } from 'rxjs';
import { debounceTime } from 'rxjs/operators';
import { TabsService } from './tabs.service';
import * as i0 from "@angular/core";
import * as i1 from "./tabs.service";
import * as i2 from "@angular/common";
const _c0 = ["scrollContainer"];
const _c1 = ["activeBar"];
const _c2 = ["*"];
function TabsComponent_div_6_div_1_ng_container_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementContainer(0);
} }
function TabsComponent_div_6_div_1_Template(rf, ctx) { if (rf & 1) {
    const _r1 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "div", 10);
    i0.ɵɵlistener("click", function TabsComponent_div_6_div_1_Template_div_click_0_listener() { i0.ɵɵrestoreView(_r1); const ctx_r1 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r1.prev()); });
    i0.ɵɵtemplate(1, TabsComponent_div_6_div_1_ng_container_1_Template, 1, 0, "ng-container", 11);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(2);
    const paginator_r3 = i0.ɵɵreference(8);
    i0.ɵɵproperty("ngStyle", ctx_r1.background);
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngTemplateOutlet", paginator_r3);
} }
function TabsComponent_div_6_div_2_ng_container_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementContainer(0);
} }
function TabsComponent_div_6_div_2_Template(rf, ctx) { if (rf & 1) {
    const _r4 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "div", 12);
    i0.ɵɵlistener("click", function TabsComponent_div_6_div_2_Template_div_click_0_listener() { i0.ɵɵrestoreView(_r4); const ctx_r1 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r1.next()); });
    i0.ɵɵtemplate(1, TabsComponent_div_6_div_2_ng_container_1_Template, 1, 0, "ng-container", 11);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(2);
    const paginator_r3 = i0.ɵɵreference(8);
    i0.ɵɵproperty("ngStyle", ctx_r1.background);
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngTemplateOutlet", paginator_r3);
} }
function TabsComponent_div_6_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div", 7);
    i0.ɵɵtemplate(1, TabsComponent_div_6_div_1_Template, 2, 2, "div", 8)(2, TabsComponent_div_6_div_2_Template, 2, 2, "div", 9);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngIf", ctx_r1.shouldShowPrev);
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngIf", ctx_r1.shouldShowNext);
} }
function TabsComponent_ng_template_7_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "button", 13);
    i0.ɵɵelement(1, "i", 14);
    i0.ɵɵelementEnd();
} }
export class TabsComponent {
    constructor(_cdRef, _tabsService) {
        this._cdRef = _cdRef;
        this._tabsService = _tabsService;
        this.size = 'md';
        this.maskColor = '#373737';
        this.tabs = new QueryList();
        this._paginationTolerance = 100;
    }
    ngOnInit() {
        const scrollStop$ = fromEvent(this.scrollContainer.nativeElement, 'scroll');
        const windowResizeStop$ = fromEvent(window, 'resize');
        this._scrollAndResizeSub = merge(scrollStop$, windowResizeStop$)
            .pipe(debounceTime(50))
            .subscribe(_ => this._cdRef.detectChanges());
        this.subscribeToActiveChange();
        this.subscribeToActiveBarTransitionEnd();
    }
    ngAfterContentInit() {
        this.subscribeToTabsChange();
    }
    subscribeToActiveChange() {
        this._activeChangeSub = this._tabsService.activeChange.subscribe(tab => {
            this.scrollToTabIfRequired(tab);
            setTimeout(() => {
                this._cdRef.detectChanges();
            }, 0);
        });
    }
    subscribeToTabsChange() {
        this._tabsChangeSub = this.tabs.changes.subscribe(tabs => {
            setTimeout(() => {
                this._cdRef.detectChanges();
            }, 0);
        });
    }
    subscribeToActiveBarTransitionEnd() {
        this._transitionEndSub = fromEvent(this.activeBar.nativeElement, 'transitionend')
            .pipe(debounceTime(50))
            .subscribe(() => {
            console.log('transition ended');
            this._cdRef.detectChanges();
        });
    }
    getActiveTab() {
        return this.tabs.filter(t => t.isActive)[0];
    }
    get tabSizeClass() {
        return `nav-${this.size}`;
    }
    getActiveStyles() {
        const tab = this.getActiveTab();
        if (tab) {
            return {
                width: tab.elRef.nativeElement.getBoundingClientRect().width + 'px',
                left: tab.elRef.nativeElement.offsetLeft + 'px'
            };
        }
        return {};
    }
    getScrollEl() {
        return this.scrollContainer.nativeElement;
    }
    get background() {
        return {
            'background': `linear-gradient(to left, rgba(0,0,0,0), ${this.maskColor})`
        };
    }
    get clientWidth() {
        return this.getScrollEl().clientWidth;
    }
    get shouldShowPagination() {
        return +(this.getScrollEl().scrollWidth / this.clientWidth).toFixed(1) >= 1;
    }
    get shouldShowPrev() {
        return this.getScrollEl().scrollLeft >= 1;
    }
    get shouldShowNext() {
        return this.getScrollEl().scrollLeft + this.clientWidth < this.getScrollEl().scrollWidth;
    }
    prev() {
        this.getScrollEl().scrollLeft -= (this.clientWidth - this._paginationTolerance);
    }
    next() {
        this.getScrollEl().scrollLeft += (this.clientWidth - this._paginationTolerance);
    }
    scrollToTabIfRequired(tab) {
        const offsetLeft = tab.elRef.nativeElement.offsetLeft;
        const position = {
            left: offsetLeft,
            right: offsetLeft + tab.elRef.nativeElement.clientWidth
        };
        const shouldScrollLeft = position.left < this.getScrollEl().scrollLeft;
        const shouldScrollRight = position.right > (this.getScrollEl().scrollLeft + this.clientWidth);
        if (shouldScrollLeft) {
            this.getScrollEl().scrollLeft = position.left - 30;
        }
        else if (shouldScrollRight) {
            this.getScrollEl().scrollLeft = position.right - this.clientWidth + 12 + 30; // plus 12 for margin
        }
    }
    ngOnDestroy() {
        this._scrollAndResizeSub.unsubscribe();
        this._activeChangeSub.unsubscribe();
        this._transitionEndSub.unsubscribe();
        this._tabsChangeSub.unsubscribe();
    }
}
TabsComponent.ɵfac = function TabsComponent_Factory(t) { return new (t || TabsComponent)(i0.ɵɵdirectiveInject(i0.ChangeDetectorRef), i0.ɵɵdirectiveInject(i1.TabsService)); };
TabsComponent.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: TabsComponent, selectors: [["nw-tabs"]], contentQueries: function TabsComponent_ContentQueries(rf, ctx, dirIndex) { if (rf & 1) {
        i0.ɵɵcontentQuery(dirIndex, TabDirective, 4);
    } if (rf & 2) {
        let _t;
        i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.tabs = _t);
    } }, viewQuery: function TabsComponent_Query(rf, ctx) { if (rf & 1) {
        i0.ɵɵviewQuery(_c0, 7);
        i0.ɵɵviewQuery(_c1, 7);
    } if (rf & 2) {
        let _t;
        i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.scrollContainer = _t.first);
        i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.activeBar = _t.first);
    } }, inputs: { size: "size", maskColor: "maskColor" }, features: [i0.ɵɵProvidersFeature([TabsService])], ngContentSelectors: _c2, decls: 9, vars: 3, consts: [["scrollContainer", ""], ["activeBar", ""], ["paginator", ""], [1, "scroll-container"], ["role", "tablist", 1, "nav", "nav-tabs", 3, "ngClass"], [1, "nav-tabs-active-bar", 3, "ngStyle"], ["class", "pagination-container", 4, "ngIf"], [1, "pagination-container"], ["class", "prev-page", 3, "ngStyle", "click", 4, "ngIf"], ["class", "next-page", 3, "ngStyle", "click", 4, "ngIf"], [1, "prev-page", 3, "click", "ngStyle"], [4, "ngTemplateOutlet"], [1, "next-page", 3, "click", "ngStyle"], [1, "btn", "btn-md", "btn-ghost-alt"], [1, "fas", "fa-chevron-left"]], template: function TabsComponent_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵprojectionDef();
        i0.ɵɵelementStart(0, "div", 3, 0)(2, "ul", 4);
        i0.ɵɵprojection(3);
        i0.ɵɵelement(4, "li", 5, 1);
        i0.ɵɵelementEnd()();
        i0.ɵɵtemplate(6, TabsComponent_div_6_Template, 3, 2, "div", 6)(7, TabsComponent_ng_template_7_Template, 2, 0, "ng-template", null, 2, i0.ɵɵtemplateRefExtractor);
    } if (rf & 2) {
        i0.ɵɵadvance(2);
        i0.ɵɵproperty("ngClass", ctx.tabSizeClass);
        i0.ɵɵadvance(2);
        i0.ɵɵproperty("ngStyle", ctx.getActiveStyles());
        i0.ɵɵadvance(2);
        i0.ɵɵproperty("ngIf", ctx.shouldShowPagination);
    } }, dependencies: [i2.NgClass, i2.NgIf, i2.NgTemplateOutlet, i2.NgStyle], styles: ["[_nghost-%COMP%], ul[_ngcontent-%COMP%] {\n            position: relative;\n        }"], changeDetection: 0 });
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(TabsComponent, [{
        type: Component,
        args: [{ selector: 'nw-tabs', template: `
        <div class="scroll-container" #scrollContainer>
            <ul class="nav nav-tabs" [ngClass]="tabSizeClass" role="tablist">
                <ng-content></ng-content>

                <li #activeBar class="nav-tabs-active-bar" [ngStyle]="getActiveStyles()"></li>
            </ul>
        </div>

        <div class="pagination-container" *ngIf="shouldShowPagination">
            <div class="prev-page" *ngIf="shouldShowPrev" (click)="prev()" [ngStyle]="background">
                <ng-container *ngTemplateOutlet="paginator"></ng-container>
            </div>
            <div class="next-page" *ngIf="shouldShowNext" (click)="next()" [ngStyle]="background">
                <ng-container *ngTemplateOutlet="paginator"></ng-container>
            </div>
        </div>

        <ng-template #paginator>
            <button class="btn btn-md btn-ghost-alt">
                <i class="fas fa-chevron-left"></i>
            </button>
        </ng-template>
     `, providers: [TabsService], changeDetection: ChangeDetectionStrategy.OnPush, styles: ["\n        :host, ul {\n            position: relative;\n        }\n    "] }]
    }], () => [{ type: i0.ChangeDetectorRef }, { type: i1.TabsService }], { size: [{
            type: Input
        }], maskColor: [{
            type: Input
        }], scrollContainer: [{
            type: ViewChild,
            args: ['scrollContainer', { static: true }]
        }], activeBar: [{
            type: ViewChild,
            args: ['activeBar', { static: true }]
        }], tabs: [{
            type: ContentChildren,
            args: [TabDirective]
        }] }); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(TabsComponent, { className: "TabsComponent" }); })();
