import { ComponentFactoryResolver, ApplicationRef, Injector, TemplateRef } from '@angular/core';
import { IToast } from './IToast';
import { Toast } from './Toast';
import { IToastConfig } from './IToastConfig';
import * as i0 from "@angular/core";
export declare class Toaster {
    private _cfr;
    private _appRef;
    private _injector;
    private _toastPortal;
    private _outlet;
    private _toastsComponentRef;
    private _config;
    constructor(_cfr: ComponentFactoryResolver, _appRef: ApplicationRef, _injector: Injector);
    private _attachOutlet;
    show(toast: IToast): Toast;
    success(message: string | TemplateRef<any>): Toast;
    error(message: string | TemplateRef<any>): Toast;
    dismiss(toast: Toast): void;
    isToastActive(toast: Toast): boolean;
    /**
     * Set the configuration values for a `Toaster` instance. This can only be called once
     * per `Toaster` instance and must be called before the outlet is created
     *
     * @param config Configuration settings for the Toaster
     */
    setConfig(config: IToastConfig): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<Toaster, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<Toaster>;
}
